import { select, selectAll, arc } from 'd3';
import 'pig';

// Window Variables
const time = 2000;
const svg = select('svg');
const width = +svg.attr('width');
const height = +svg.attr('height');
const radius = 60
const g = svg.append('g')
  .attr('transform', `translate(${70}, ${height/2})`)

g.transition().duration(2000)
  .attr('fill', 'red')
  .attr('transform', `translate(${width-radius-10}, ${height/2})`)


// Face Shape
const circle = g
  .append('circle')
    .attr('r', radius)
    .attr('fill', 'rgb(48, 155, 255)')
    .attr('stroke', 'rgb(16, 72, 124)')
  .transition().duration(time)
	.attr('fill', 'red')


// Eyes Shapes
const pupilRadius = 5
const eyeRadius = 20
const eyeYOffset = -20;
const eyeXOffset = 0;
const eyeSpacing = eyeRadius;

const eyesG = g
  .append('g')
    .attr('transform', `translate(${eyeXOffset}, ${eyeYOffset})`);
eyesG
  .transition().duration(time)
	.attr('transform', `translate(${eyeXOffset+15}, ${eyeYOffset+10})`)

const leftEye = eyesG
  .append('circle')
	.attr('fill', 'black')
    .attr('r', eyeRadius)
    .attr('cx', -eyeSpacing)
  .transition().duration(time)
	.attr('r', eyeRadius-10)
const leftPupil = eyesG
  .append('circle')
    .attr('r', pupilRadius)
	.attr('fill', 'white')
    .attr('cx', -eyeSpacing);

const rightEye = eyesG
  .append('circle')
	.attr('fill', 'black')
    .attr('r', eyeRadius)
    .attr('cx', eyeSpacing);
const rightPupil = eyesG
  .append('circle')
	.attr('r', pupilRadius)
	.attr('fill', 'white')
	.attr('cx', eyeSpacing)
  .transition().duration(time)
    .attr('r', pupilRadius+10);
	


// Eyebrow Shapes
const eyebrowWidth = 20;
const eyebrowHeight = 5;
const eyebrowYOffset = -25;

const eyebrowsG = eyesG
  .append('g')
    .attr('transform', `translate(0, ${eyebrowYOffset})`);

eyebrowsG
  .transition().duration(time/4)
    .attr('transform', `translate(0, ${eyebrowYOffset-10})`)
  .transition(time/2)
    .attr('transform', `translate(-5, ${eyebrowYOffset})`);

const leftEyebrow = eyebrowsG
  .append('rect')
	.attr('fill', 'rgb(164, 73, 255)')
    .attr('x', -eyeSpacing - eyebrowWidth / 2)
    .attr('width', eyebrowWidth)
    .attr('height', eyebrowHeight)
  .transition().duration(time)
	.attr('transform', 'rotate(45)translate(10, 10)')

const rightEyebrow = eyebrowsG
  .append('rect')
	.attr('fill', 'rgb(164, 73, 255)')
    .attr('x', eyeSpacing - eyebrowWidth / 2)
    .attr('width', eyebrowWidth)
    .attr('height', eyebrowHeight)
  .transition().duration(time)
	.attr('transform', 'rotate(-45)translate(-10, 10)')


// Mouth object
const mouthRadius = 10;
const mouthYOffset = 10;
const mouthXOffset = 0;
const mouthG = g.append('g');

const mouth = mouthG
  .append('circle')
	.attr('r', mouthRadius)
	.attr('cy', mouthYOffset)
	.attr('fill', 'rgb(226, 129, 18)')
  .transition().duration(time)
	.attr('r', mouthRadius+10)
const innerMouth = mouthG
  .append('circle')
	.attr('r',  mouthRadius-5)
	.attr('cy', mouthYOffset)
	.attr('fill', 'black')
  .transition().duration(time)
    .attr('r', mouthRadius+10)
/*
  .append('path')
    .attr('fill', 'black')
    .attr('transform', `translate(${mouthXOffset}, ${mouthYOffset})`)
    .attr('d', arc()({
      innerRadius: 0,
      outerRadius: mouthRadius,
      startAngle: 0,
      endAngle: 2 * Math.PI
    }));
*/


mouthG.transition().duration(time)
  .attr('transform', `translate(${mouthXOffset+15}, ${mouthYOffset+10})`)




