import { select, arc } from 'd3';


const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const eyeSpacing = 50;
const eyeYOffset = -50;
const eyeRadius = 40;
const eyebrowWidth = 100;
const eyebrowHeight = 20;
const eyebrowYOffset = -80;
const irisRadius = 25;
const pupilRadius = 10;
const mouthRadius = 80;

const faceWidth = 200;
const faceHeight = 200;

const g = svg.append('g')
  .attr('transform', `translate(${width - 110}, ${height / 2})`);  

//Hulk Smash
const faceBackground = g
  .append('rect')
    .attr('x', -faceWidth / 2)
    .attr('y', -faceHeight / 2)
    .attr('rx', 50)
    .attr('width', faceWidth)
    .attr('height', faceHeight)
    .attr('fill', 'yellow')
  .transition().duration(2000)
    .attr('fill', 'green')


//Eyes
const eyesG = g
  .append('g')
    .attr('transform', `translate(0, ${eyeYOffset})`)
    .attr('fill', 'white');

const leftEye = eyesG
  .append('circle')
    .attr('r', eyeRadius)
    .attr('cx', -eyeSpacing);

const rightEye = eyesG
  .append('circle')
    .attr('r', eyeRadius)
    .attr('cx', eyeSpacing);


//Irises
const irisG = eyesG
  .append('g')
    .attr('fill', 'blue');

const leftIris = irisG
  .append('circle')
    .attr('r', irisRadius)
    .attr('cx', -eyeSpacing)

const rightIris = irisG
  .append('circle')
    .attr('r', irisRadius)
    .attr('cx', eyeSpacing)


//Pupils 
const pupilG = irisG
  .append('g')
    .attr('fill', 'black');

const leftPupil = pupilG
  .append('circle')
    .attr('r', pupilRadius)
    .attr('cx', -eyeSpacing)

const rightPupil = pupilG
  .append('circle')
    .attr('r', pupilRadius)
    .attr('cx', eyeSpacing)


// Eyebrows
const eyebrowsG = eyesG
  .append('g')
    .attr('transform', `translate(0, ${eyebrowYOffset})`)
    .attr('fill', 'brown');

const leftEyebrow = eyebrowsG
  .append('rect')
    .attr('x', -eyeSpacing - eyebrowWidth / 2)
    .attr('width', eyebrowWidth)
    .attr('height', eyebrowHeight)
  .transition().duration(2000)
    .attr('transform', `rotate(45)translate(50, 50)`);

const rightEyebrow = eyebrowsG
  .append('rect')
    .attr('x', eyeSpacing - eyebrowWidth / 2)
    .attr('width', eyebrowWidth)
    .attr('height', eyebrowHeight)
  .transition().duration(2000)
    .attr('transform', `rotate(-45)translate(-50, 50)`); 

const mouth = g
  .append('path')
    .attr('d', arc()({
      innerRadius: 0,
      outerRadius: mouthRadius,
      startAngle: Math.PI / 2,
      endAngle: Math.PI * 3 / 2
    }));

mouth
  .transition().duration(2000)
    .attr('transform', `rotate(180)translate(0, ${-mouthRadius})`);